\name{Stem-package}
%\alias{Stem-package}
\alias{Stem}
\docType{package}
\title{
Analysis of spatio-temporal hierarchical models
}
\description{
This package focuses on spatio-temporal hierarchical models. The package includes functions for maximum likelihood estimation (based on Kalman filtering and EM algorithm), for computing the parameter standard errors (using a parametric spatio-temporal bootstrap) and for spatial mapping.
}
\details{
\tabular{ll}{
Package: \tab Stem\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2009-01-27\cr
License: \tab  GPL (>= 2)\cr
LazyLoad: \tab yes\cr
}
}

\author{
Michela Cameletti \email{ michela.cameletti@unibg.it }
}

\references{

Amisigo, B.A., Van De Giesen, N.C. (2005) \emph{Using a spatio-temporal dynamic state-space model with the EM algorithm to patch gaps in daily riverflow series}. Hydrology and Earth System Sciences 9, 209--224.

Fasso', A., Cameletti, M., Nicolis, O. (2007) \emph{Air quality monitoring using heterogeneous networks}. Environmetrics 18, 245--264.

Fasso', A., Cameletti, M. (2007) \emph{A general spatio-temporal model for environmental data}. Tech.rep. n.27 \emph{Graspa} - The Italian Group of Environmental Statistics - \url{ http://www.graspa.org }.

Fasso', A., Cameletti, M. (2009) \emph{A unified statistical approach for simulation, modelling, analysis and mapping of environmental data}.
Accepted for publication by \emph{Simulation: transaction of the Society for Modeling and Simulation International}.

Mc Lachlan, G.J., Krishnan, T. (1997) \emph{The EM Algorithm and Extensions}. Wiley, New York.

Shumway, R.H., Stoffer, D.S. (2006) \emph{Time Series Analysis and Its Applications: with R Examples}. Springer, New York.

Xu, K., Wikle, C.K. (2007) \emph{Estimation of parameterized spatio-temporal dynamic models}. Journal of Statistical Inference and Planning 137,  567--588.


}

\keyword{ spatial }
